
var rsvp = require('rsvp')
var fs = require('fs')

function extend(dest, src) {
  for (var k in src) { dest[k] = src[k] }
  return dest
}

var JSONStore = function(filepath) {
  this.filepath = filepath
}

JSONStore.prototype = {
  
  _write: function(data) {
    var filepath = this.filepath
    return new rsvp.Promise(function(res, rej) {
      fns._read().then(function(json) {
        var replacement = extend(json, data)
        fs.writeFile(filepath, JSON.stringify(replacement), { w:1 }, function(e) {
          e ? rej(e) : res(replacement)
        })
      })
    })
  },

  _read: function() {
    var filepath = this.filepath
    return new rsvp.Promise(function(res, rej) {
      fs.readFile(filepath, 'utf8', function(e, str) {
        e ? rej(e) : res(JSON.parse(str))          
      })
    })
  },

  set: function(data) {
    return this._write(data)
  },

  get: function(key) {
    return this._read().then(function(json) {
      return json[key]
    })
  }
}

module.exports = function(filepath) {
  return new JSONStore(filepath)
}
